'use strict';

var fs         = require('fs'),
	path       = require('path'),
	extend     = require('deep-extend');

var configFile = '.pleeeaserc';

var options = {
	"input": ['*.css'],
	"output": 'app.min.css',

	"fallbacks": {
		"autoprefixer": true,
		"variables": true,
		"rem": true,
		"pseudoElements": true
	},
	"optimizers": {
		"import": true,
		"mqpacker": true,
		"minifier": true
	}
};

// check for .pleeeaserc config file
if (fs.existsSync !== undefined && path.existsSync !== undefined) {

	if ((fs.existsSync || path.existsSync)(configFile)) {
		var config = JSON.parse(fs.readFileSync(configFile));

		options = extend(options, config);

	}

}

module.exports = options;